/**
* DO NOT EDIT THIS FILE.
* See the following change record for more information,
* https://www.drupal.org/node/2815083
* @preserve
**/

(function ($, Drupal, drupalSettings) {
  drupalSettings.dialog = {
    autoOpen: true,
    dialogClasses: '',
    dialogShowHeader: true,
    dialogShowHeaderTitle: true,
    buttonClass: 'btn',
    buttonPrimaryClass: 'btn-primary',
    close: function close(event) {
      Drupal.bs4_modal(event.target).close();
      Drupal.detachBehaviors(event.target, null, 'unload');
    }
  };

  Drupal.bs4_modal = function (element, options) {
    var undef = void 0;
    var $element = $(element);
    var dialog = {
      open: false,
      returnValue: undef
    };

    function openDialog(settings) {
      settings = $.extend({}, drupalSettings.dialog, options, settings);

      $(window).trigger('dialog:beforecreate', [dialog, $element, settings]);


      if (settings.dialogClasses !== undefined) {
        $('.modal-dialog', $element).removeAttr('class').addClass('modal-dialog').addClass(settings.dialogClasses);
      }

      // The modal dialog header
      if (settingIsTrue(settings.dialogShowHeader)) {
        var modalHeader = '<div class="modal-header">';
        if (settingIsTrue(settings.dialogShowHeaderTitle)) {
          modalHeader += '<h5 class="modal-title">' + settings.title + '</h5>';
        }
        modalHeader += '<button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>';
        modalHeader += '</div>';
        $(modalHeader).prependTo($('.modal-dialog .modal-content', $element));
      }

      // The modal dialog footer
      if (settingIsTrue(settings.drupalAutoButtons) && settings.buttons.length > 0) {
        var modalFooter = '<div class="modal-footer">';
        $.each(settings.buttons, function () {
          var classes = [ settings.buttonClass, settings.buttonPrimaryClass ];
          var action = '';
          if ($('#' + this.id).is('a')) {
            action = 'jQuery(\'#' + this.id + '\').click();';
          } else {
            action = 'jQuery(\'#' + this.id + '\').trigger(\'mousedown\').trigger(\'mouseup\').trigger(\'click\');';
          }
          modalFooter += '<button type="button" class="' + classes.join(' ') + '" onclick="' + action + '">' + this.text + '</button>';
        });
        modalFooter += '</div>';
        $(modalFooter).appendTo($('.modal-dialog .modal-content', $element));
      }

      $element.modal(settings);
      $element.modal('show');
      // dialog.open = true;
      $(window).trigger('dialog:aftercreate', [dialog, $element, settings]);
    }

    function closeDialog(value) {
      $(window).trigger('dialog:beforeclose', [dialog, $element]);
      $element.modal('hide');
      dialog.returnValue = value;
      dialog.open = false;
      $(window).trigger('dialog:afterclose', [dialog, $element]);
    }

    function settingIsTrue(setting) {
      return (setting !== undefined && (setting === true || setting === 'true'))
   }

    dialog.show = function () {
      openDialog({ modal: false });
    };
    dialog.showModal = function () {
      openDialog({ modal: true });
    };
    dialog.close = closeDialog;

    $element.on('hide.bs.modal', function (e) {
       $(window).trigger('dialog:beforeclose', [dialog, $element]) ;
    });

    $element.on('hide.bs.modal', function (e) {
       $(window).trigger('dialog:afterclose', [dialog, $element]) ;
    });

    return dialog;
  };
})(jQuery, Drupal, drupalSettings);
